



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>CLR查找和加载程序集的方式（一）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">CLR查找和加载程序集的方式（一）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-27 06:00:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　C#开发者在开发WinForm程序、Asp.Net Web(MVC)程序等，不可避免的在项目中引用许多第三方的DLL程序集，</p>
<p>编译后引用的dll都放在根目录下。以我个人作品&nbsp;<a href="http://www.cnblogs.com/SavionZhang/p/5031757.html" rel="external nofollow noreferrer"><strong>AutoProject Studio 自动化项目生成器</strong></a> 为例，由于需要支持SQL Server、</p>
<p>Oracle、MySQL、PostgreSQL、DB2、Sybase、Infomix、SQLite、Access等多种数据库，所以引用了DmProvider.dll、</p>
<p>IBM.Data.DB2.dll、IBM.Data.Informix.dll、MySql.Data.dll、Npgsql.dll、SQLite.Interop.dll、System.Data.dll、</p>
<p>System.Data.OracleClient.dll、Sybase.AdoNet4.AseClient.dll 等DLL，参考下图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/142275/201703/142275-20170310161935357-276919483.png" /></p>
<p>随着项目的日益增大，根目录下充满了各种各样的dll，非常的不美观。如果能够把dll按照想要的目录来存放，那么系统就美观多了。</p>
<p>此问题就涉及到&nbsp;<strong>CLR查找和加载程序集的方式</strong>。</p>
<div><strong>系统搜索dll的目录以及顺序</strong></div>
<p>　　CLR解析一个程序集会在一个根目录内进行搜索，整个探索过程又称Probing，这个根目录很显然就是当前包含当前程序集的目录。</p>
<p>　　AppDomainSetup这个类存储着探索目录的信息，其成员包括： ApplicationBase 、 PrivateBinPath 。</p>
<p>程序搜索DLL的顺序如下(区分强名称签名、没有强名称签名的程序集)</p>
<div><strong>没有做强名称签名的程序集</strong></div>
<ol><li>程序的根目录</li>
<li>根目录下面，与被引用程序集同名的子目录</li>
<li>根目录下面被明确定义为私有目录的子目录</li>
<li>在目录中查找的时候，如果dll查找不到，则会尝试查找同名的exe</li>
<li>如果程序集带有区域性，而不是语言中立的，则还会尝试查找以语言区域命名的子目录</li></ol>
<div><strong>强名称签名的程序集</strong></div>
<ol><li>全局程序集缓存</li>
<li>如果有定义codebase，则以codebase定义为准，如果 codebase指定的路径找不到，则直接报告错误</li>
<li>程序的根目录</li>
<li>根目录下面，与被引用程序集同名的子目录</li>
<li>根目录下面被明确定义为私有目录的子目录</li>
<li>在目录中查找的时候，如果dll查找不到，则会尝试查找同名的exe</li>
<li>如果程序集带有区域性，而不是语言中立的，则还会尝试查找以语言区域命名的子目录</li></ol>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/142275/201703/142275-20170310171225701-1058155762.png" /><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/142275/201703/142275-20170310171849139-977374762.png" /></p>
<p>如何让程序识别不同目录下的dll?<br />我们看到，上面的顺序无论是否有强名称签名看，都提到了一个名词 &ldquo;私有目录&rdquo;。</p>
<div><strong>方法一：配置App.config(web.config)文件的 privatePath &mdash;&mdash;【推荐】</strong></div>
<p>针对该问题，微软提供了<a href="https://msdn.microsoft.com/zh-cn/library/823z9h8w(v=vs.100).aspx" rel="external nofollow noreferrer"><strong>&lt;probing&gt; 元素</strong></a>， 在配置文件中自定义存储目录。</p>
<div>
<pre class="prettyprint linenums"> &lt;?xml version="1.0" encoding="utf-8" ?&gt;<br />
 &lt;configuration&gt;<br />
   &lt;runtime&gt;<br />
     &lt;!--双核以上计算机请开启下面的选项为 true--&gt;<br />
     &lt;gcServer enabled="false" /&gt;<br />
     &lt;assemblyBinding xmlns="urn:schemas-microsoft-com:asm.v1"&gt;<br />
       &lt;probing privatePath="bin;bin2\subbin;bin3" /&gt;<br />
     &lt;/assemblyBinding&gt;<br />
   &lt;/runtime&gt;<br />
 &lt;/configuration&gt;</pre>
</div>
<ul><li><strong>configuration</strong>：每个配置文件中的根元素，常用语言 runtime 和 .NET Framework 应用程序会使用这些文件。</li>
<li><strong>runtime</strong>：包含程序集绑定和垃圾回收的相关信息。</li>
<li><strong>assemblyBinding</strong>：包含有关程序集版本重定向和程序集位置的信息。</li>
<li><strong>privatePath</strong>：必选特性。指定可能包含程序集的应用程序基目录的子目录。 用分号分隔每个子目录。</li></ul>
<p>上述&nbsp;privatePath中的"bin;bin2\subbin;bin3"，其中bin是默认编译输出目录，bin2、bin3 是自定义目录，subbin是bin2下的子目录。</p>
<p>把DLL分别放入上述目录中，程序运行正常。这是最简单的方法，当然也有一定的局限性，就是没法对DLL做控制。另外，无法解决第三方&nbsp;<code>DllImport</code>&nbsp;中引入的程序集不在根目录下的问题。但是该方法基本解决了分目录存储的问题。</p>
<div><strong>方法二：订阅程序集解析事件 AssemblyResolve 在代码中解析</strong></div>
<p>应用程序集域中支持在程序集解析时的处理： AppDomain.CurrentDomain.AssemblyResolve += CurrentDomain_AssemblyResolve;&nbsp;通过这个事件，我们可以在程序集解析时，根据不同的程序集做不用的处理，比如加载x86的程序集还是64位的程序集，当然也就可以指定程序集目录了，这也正是 Assembly.Load 和 Assembly.LoadFrom 等方法的用武之地。</p>
<div>
<pre class="prettyprint linenums"> using System;<br />
 using System.IO;<br />
 using System.Reflection;<br />
 using System.Windows.Forms;

 namespace WindowsFormsApplication1<br />
 {<br />
     static class Program<br />
     {<br />
         /// &lt;summary&gt;<br />
         /// 应用程序的主入口点。<br />
         /// &lt;/summary&gt;<br />
         [STAThread]<br />
         static void Main()<br />
         {<br />
             Application.EnableVisualStyles();<br />
             Application.SetCompatibleTextRenderingDefault(false);

            <strong> AppDomain.CurrentDomain.AssemblyResolve += CurrentDomain_AssemblyResolve;<br />
</strong><br />
             Application.Run(new Form1());<br />
         }

         /// &lt;summary&gt;<br />
         /// 解析当前应用程序域内指定目录下的DLL<br />
         /// &lt;/summary&gt;<br />
         /// &lt;param name="sender"&gt;&lt;/param&gt;<br />
         /// &lt;param name="args"&gt;&lt;/param&gt;<br />
         /// &lt;returns&gt;&lt;/returns&gt;<br />
         private static Assembly CurrentDomain_AssemblyResolve(object sender,ResolveEventArgs args)<br />
         {<br />
             string path = Path.Combine(AppDomain.CurrentDomain.BaseDirectory,@"xx目录\");<br />
             path = Path.Combine(path,args.Name.Split(',')[]);<br />
             path = string.Format(@"{0}.dll",path);<br />
             return Assembly.LoadFrom(path);<br />
         }<br />
     }<br />
 }</pre>
</div>
<div><strong>方法三：设置&nbsp;AppDomainSetup类的PrivateBinPath属性</strong></div>
<div>
<pre class="prettyprint linenums"> using System;<br />
 using System.IO;<br />
 using System.Reflection;<br />
 using System.Windows.Forms;

 namespace WindowsFormsApplication1<br />
 {<br />
     static class Program<br />
     {<br />
         /// &lt;summary&gt;<br />
         /// 应用程序的主入口点。<br />
         /// &lt;/summary&gt;<br />
         [STAThread]<br />
         static void Main()<br />
         {<br />
             Application.EnableVisualStyles();<br />
             Application.SetCompatibleTextRenderingDefault(false);

             SetPrivateBinPath();//设置程序集所在的指定目录并解析DLL

             Application.Run(new Form1());<br />
         }

         /// &lt;summary&gt;<br />
         /// 设置程序集所在的指定目录并解析DLL<br />
         /// &lt;/summary&gt;<br />
         private static void SetPrivateBinPath()<br />
         {<br />
             if(AppDomain.CurrentDomain.IsDefaultAppDomain())<br />
             {<br />
                 string appName = AppDomain.CurrentDomain.FriendlyName;<br />
                 var currentAssembly = Assembly.GetExecutingAssembly();

                 AppDomainSetup setup = new AppDomainSetup();<br />
                 setup.ApplicationBase = Environment.CurrentDirectory;<br />
                 setup.PrivateBinPath = "xx目录";<br />
                 setup.ConfigurationFile = setup.ApplicationBase +  string.Format("\\Config\\{0}.config",appName);

                 AppDomain newDomain = AppDomain.CreateDomain("NewAppDomain",null,setup);<br />
                 int ret = newDomain.ExecuteAssemblyByName(currentAssembly.FullName);

                 AppDomain.Unload(newDomain);<br />
                 Environment.ExitCode = ret;<br />
                 Environment.Exit();<br />
                 return;<br />
             }<br />
         }<br />
     }<br />
 }</pre>
</div>
<div><strong>方法四：在加载使用到的DLL代码之前重置当前环境的目录</strong></div>
<p>通过 Environment.CurrentDirectory=customPath ，切换目录后，在调用dll方法时运行正常。</p>
<p>处理 [DllImport] 中的程序集的加载，此处提供用一种方式来处理：增加环境变量。</p>
<p>C#代码如下：</p>
<div>
<pre class="prettyprint linenums">static void AddEnvironmentPaths(IEnumerable&lt;string&gt; paths)<br />
{<br />
    var path = new[] { Environment.GetEnvironmentVariable("PATH") ?? string.Empty };

    string newPath = string.Join(Path.PathSeparator.ToString(), path.Concat(paths));

    Environment.SetEnvironmentVariable("PATH", newPath);<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy70mqr.html">模仿东京首页banner轮播，京东新闻上下滚动动画实现（动画实现）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlj2109.html">我的  vim 基本配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e06lkq.html">PAT A 1115&period; Counting Nodes in a BST &lpar;30&rpar;【二叉排序树】</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zr4enq.html">SVN File Name Case Sensitivity--SVN大小写问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql52rk8.html">学习docker</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8opvmpq.html">JavaScript - BOM</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4lw508.html">【读书笔记】iOS-NSDictionary与NSArray的比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x6elg9.html">【重构】m站重构思路</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok6xre9.html">C程序设计语言练习题1-18</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1oook8.html">caffe绘制训练过程的loss和accuracy曲线</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z75ke9.html">纳税服务系统【信息发布管理、Ueditor、异步信息交互】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgmpj48.html">pulltorefresh 设置刷新文字提示颜色</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1gwjoq.html">Mybatis框架（未完待续）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j74038.html">群晖IP地址更新问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j121og9.html">excel 删除重复项</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r16ej9.html">css实现不定高度的元素垂直居中问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ro6m48.html">JDK自带的运行监控工具JConsole观察分析Java程序的运行</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m245l0q.html">6种innodb数据字典恢复方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r522keq.html">&lbrack;洛谷 P3239&rsqb; &lbrack;HNOI2015&rsqb;亚瑟王</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjxdv69.html">第11章 拾遗5：IPv6和IPv4共存技术（3）&lowbar;NAT-PT技术【全书完】</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90mg3no8.html">Linux安装Oracle JDK替换OpenJDK详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgxx2d8.html">001 Lua相关链接</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me01m6q.html">Linux记录-sftp上传大文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdr0z79.html">kali linux工具--信息批量收集工具theharvester</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gewng48.html">shell 批量远程主机执行命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k1mk49.html">JSP循环缓存列表</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zlg2j9.html">day 21 - 1 包，异常处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz50jg8.html">Convolutional Pose Machines（理解）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zly2j9.html">springmvc 开发流程图</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jpjlx8.html">appniu踩坑</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
